package com.jpattern.orm.mapper;

import java.util.List;

import com.jpattern.orm.crud.AColumnValueGenerator;

/**
 * 
 * @author Francesco Cina
 *
 * 08/giu/2011
 */
public interface ITableMap  {

	String getSchemaName();
	
	String getTableName();
	
	String getTableNameWithSchema();
	
	String getDBColumnName( String javaFieldName );
	
	AColumnValueGenerator getGeneratorByColumnName( String columnName );
	
	AColumnValueGenerator getGeneratorByJavaFieldName( String javaFieldName );
	
	List<String> getPrimaryKeyFieldNames();
	
	List<String> getAllFieldNames();

	String getJavaFieldName(String dbColumnName);
	
}
