package com.jpattern.orm.query;

import com.jpattern.orm.exception.OrmException;

/**
 * 
 * @author Francesco Cina
 *
 * 07/lug/2011
 */
public interface IOrmCustomQuery extends IBaseOrmQuery, ICustomQuery {

	/**
	 * Set the maximum number of rows to return in the query.
	 * @param maxRows
	 * @return
	 */
	IOrmCustomQuery setMaxRows(int maxRows) throws OrmException;
	
	/**
	 * Set the query timeout for the query.
	 */
	IOrmCustomQuery setQueryTimeout(int queryTimeout);
	
	/**
	 * 
	 * @param lockMode
	 * @return
	 */
	IOrmCustomQuery setLockMode(LockMode lockMode);
}
